Bug 501924 - (mingw32-tcl) Review Request: mingw32-tcl - MinGW Windows Tool Command Language
Review Request: mingw32-tcl - MinGW Windows Tool Command Language
Status: CLOSED NEXTRELEASE
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
low Severity medium
: ---
: ---
Assigned To: Erik van Pienbroek
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2009-05-21 06:59 EDT by Thomas Sailer
Modified: 2009-05-25 17:19 EDT (History)
4 users (show)

See Also:
Fixed In Version: 8.5.7-5.fc10.1
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2009-05-25 17:17:08 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
erik-fedora: fedora‑review+
kevin: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Thomas Sailer 2009-05-21 06:59:50 EDT
Spec URL: http://sailer.fedorapeople.org/mingw32-tcl.spec
SRPM URL: http://sailer.fedorapeople.org/mingw32-tcl-8.5.6-1.fc11.src.rpm
Description:
MinGW Windows C++ wrapper for the glade library.

Approved MinGW packaging guidelines are here:
http://fedoraproject.org/wiki/Packaging/MinGW
Comment 1 Thomas Sailer 2009-05-21 07:04:07 EDT
Description should be:
MinGW Windows Tool Command Language
Comment 2 Erik van Pienbroek 2009-05-21 09:22:54 EDT
This one is quite hard to read, due to the frequent use of macros. However, I don't think it can be done any other way, so I'll do my best to read through them.

----

The %files list contains some redundant entries:
 %dir %{_mingw32_libdir}/%{name1}%{majorver}
 %dir %{_mingw32_libdir}/dde*
 %dir %{_mingw32_libdir}/reg*
 %{_mingw32_libdir}/%{name1}%{majorver}/*
 %{_mingw32_libdir}/dde*/*
 %{_mingw32_libdir}/reg*/* 

These can be simplified to:
 %{_mingw32_libdir}/%{name1}%{majorver}/
 %{_mingw32_libdir}/dde*/
 %{_mingw32_libdir}/reg*/

----

For readability, you might want to move this piece of code to the top of the .spec file:
 # don't run "make test" by default
 %{?_without_check: %define _without_check 0}
 %{!?_without_check: %define _without_check 1}

----

Is the rename of the import libraries from .a to .dll.a really necessary? AFAIK, this is only needed for libtool based libraries (which tcl isn't)

----

The native tcl package is now at version 8.5.7. You might want to update to that version too. See http://cvs.fedoraproject.org/viewvc/rpms/tcl/devel/tcl.spec?view=log for the complete list of changes
Comment 3 Thomas Sailer 2009-05-21 11:16:32 EDT
(In reply to comment #2)

Thanks for taking! That was quick!

> This one is quite hard to read, due to the frequent use of macros. However, I
> don't think it can be done any other way, so I'll do my best to read through
> them.

I modified the native tcl package spec file. 

> The %files list contains some redundant entries:

Fixed.

> For readability, you might want to move this piece of code to the top of the
> .spec file:
>  # don't run "make test" by default
>  %{?_without_check: %define _without_check 0}
>  %{!?_without_check: %define _without_check 1}

This is again from the native spec file. I kept it there to minimize the differences. So the %check section could probably completely go...

> Is the rename of the import libraries from .a to .dll.a really necessary?
> AFAIK, this is only needed for libtool based libraries (which tcl isn't)

I don't think the renaming is strictly necessary. I did it to make it extra clear that the .a files are implibs, not static libraries...

> The native tcl package is now at version 8.5.7. You might want to update to
> that version too. See

Woohoo. Just when you think you're up to date :)
But there does not seem to be a successful build of 8.5.7 in koji. So I'm ahead now :)

Updated:
Spec URL: http://sailer.fedorapeople.org/mingw32-tcl.spec
SRPM URL: http://sailer.fedorapeople.org/mingw32-tcl-8.5.7-1.fc11.src.rpm
Comment 4 Erik van Pienbroek 2009-05-21 14:38:17 EDT
(In reply to comment #3)
> Thanks for taking! That was quick!

I'm waiting for somebody to review my review requests, so it's best to do other reviews in return :)

> > For readability, you might want to move this piece of code to the top of the
> > .spec file:
> >  # don't run "make test" by default
> >  %{?_without_check: %define _without_check 0}
> >  %{!?_without_check: %define _without_check 1}
> 
> This is again from the native spec file. I kept it there to minimize the
> differences. So the %check section could probably completely go...

Yeah, I've also seen it in the native spec file. However, I still think such pieces of code need to be near the top of .spec files as it helps people who are manually rebuilding the package to find out there's an option to enable the testsuite. Right now, it's hidden somewhere in the .spec file and easily overlooked.
 
> > Is the rename of the import libraries from .a to .dll.a really necessary?
> > AFAIK, this is only needed for libtool based libraries (which tcl isn't)
> 
> I don't think the renaming is strictly necessary. I did it to make it extra
> clear that the .a files are implibs, not static libraries...

Have you tried compiling TCL-based applications (or other libraries) against this package to test whether the compiler can find the .dll.a file? (Normally libtool takes care of that, but as TCL isn't libtool based it's best to verify this)
Comment 5 Thomas Sailer 2009-05-22 06:18:08 EDT
(In reply to comment #4)

I removed the %check section now, entirely.

> Have you tried compiling TCL-based applications (or other libraries) against
> this package to test whether the compiler can find the .dll.a file? (Normally
> libtool takes care of that, but as TCL isn't libtool based it's best to verify
> this)  

Yes. It links and basically works.

Updated:
Spec URL: http://sailer.fedorapeople.org/mingw32-tcl.spec
SRPM URL: http://sailer.fedorapeople.org/mingw32-tcl-8.5.7-2.fc11.src.rpm
Comment 6 Erik van Pienbroek 2009-05-22 09:56:12 EDT
$ rpmlint mingw32-tcl.spec 
0 packages and 1 specfiles checked; 0 errors, 0 warnings.
$ rpmlint mingw32-tcl-8.5.7-2.fc11.src.rpm 
1 packages and 0 specfiles checked; 0 errors, 0 warnings.
$ rpmlint mingw32-tcl-8.5.7-2.fc11.noarch.rpm 
1 packages and 0 specfiles checked; 0 errors, 0 warnings.

$ rpmquery --requires mingw32-tcl
rpmlib(PayloadFilesHavePrefix) <= 4.0-1
rpmlib(CompressedFileNames) <= 3.0.4-1
mingw32-filesystem >= 50
mingw32-runtime  
mingw32(kernel32.dll)  
mingw32(msvcrt.dll)  
mingw32(tcl85.dll)  
mingw32(user32.dll)  

$ rpmquery --provides mingw32-tcl
mingw32(tcl85.dll)  
mingw32(tclpip85.dll)  
mingw32(tcldde13.dll)  
mingw32(tclreg12.dll)  
mingw32-tcl = 8.5.7-2.fc11

$ md5sum tcl8.5.7-src.tar.gz 
f70ad8f78b5e4a9f792fe101f22b125f  tcl8.5.7-src.tar.gz
$ curl http://kent.dl.sourceforge.net/sourceforge/tcl/tcl8.5.7-src.tar.gz --quiet | md5sum
f70ad8f78b5e4a9f792fe101f22b125f  -

+ OK
! Needs to be looked into
/ Not applicable
* Overridden by MinGW guidelines

[+] Files are installed in /usr/i686-pc-mingw32/sys-root/mingw
[+] BuildRequires: mingw32-filesystem >= xx is in the .spec file
[+] Requires are OK
[+] BuildArch: noarch
[+] No man pages or info files
[+] default strip and objdump commands are overridden with mingw32 specific ones


[+] rpmlint must be run on every package. The output should be posted in the review
[+] MUST: The package must be named according to the Package Naming Guidelines
[+] MUST: The spec file name must match the base package %{name}, in the format %{name}.spec unless your package has an exemption on Package Naming Guidelines
[+] MUST: The package must meet the Packaging Guidelines
[+] MUST: The package must be licensed with a Fedora approved license and meet the Licensing Guidelines .
[+] MUST: The License field in the package spec file must match the actual license.
[+] MUST: If (and only if) the source package includes the text of the license(s) in its own file, then that file, containing the text of the license(s) for the package must be included in %doc.
[+] MUST: The spec file must be written in American English.
[+] MUST: The spec file for the package MUST be legible.
[+] MUST: The sources used to build the package must match the upstream source, as provided in the spec URL.
[+] MUST: The package must successfully compile and build into binary rpms on at least one supported architecture.
[+] MUST: If the package does not successfully compile, build or work on an architecture, then those architectures should be listed in the spec in ExcludeArch.
[+] MUST: All build dependencies must be listed in BuildRequires, except for any that are listed in the exceptions section of the Packaging Guidelines; inclusion of those as B ildRequires is optional.
[/] MUST: The spec file MUST handle locales properly. This is done by using the %find_lang macro. Using %{_datadir}/locale/* is strictly forbidden.
[*] MUST: Every binary RPM package which stores shared library files (not just symlinks) in any of the dynamic linker's default paths, must call ldconfig in %post and %postun. 
[/] MUST: If the package is designed to be relocatable, the packager must state this fact in the request for review, along with the rationalization for relocation of that specific package.
[+] MUST: A package must own all directories that it creates. 
[+] MUST: A package must not contain any duplicate files in the %files listing.
[+] MUST: Permissions on files must be set properly.
[+] MUST: Each package must have a %clean section, which contains rm -rf %{buildroot} ( or $RPM_BUILD_ROOT ).
[+] MUST: Each package must consistently use macros, as described in the macros section of Packaging Guidelines .
[+] MUST: The package must contain code, or permissable content.
[/] MUST: Large documentation files should go in a -doc subpackage.
[+] MUST: If a package includes something as %doc, it must not affect the runtime of the application.
[*] MUST: Header files must be in a -devel package.
[/] MUST: Static libraries must be in a -static package.
[/] MUST: Packages containing pkgconfig(.pc) files must 'Requires: pkgconfig' (for directory ownership and usability).
[*] MUST: If a package contains library files with a suffix (e.g. libfoo.so.1.1), then library files that end in .so (without suffix) must go in a -devel package.
[/] MUST: In the vast majority of cases, devel packages must require the base package using a fully versioned dependency: Requires: %{name} = %{version}-%{release}
[/] MUST: Packages must NOT contain any .la libtool archives, these should be removed in the spec.
[/] MUST: Packages containing GUI applications must include a %{name}.desktop file, and that file must be properly installed with desktop-file-install in the %install section.
[+] MUST: Packages must not own files or directories already owned by other packages.
[+] MUST: At the beginning of %install, each package MUST run rm -rf %{buildroot} ( or $RPM_BUILD_ROOT ). See Prepping BuildRoot For %install for details.
[+] MUST: All filenames in rpm packages must be valid UTF-8.
[+] SHOULD: If the source package does not include license text(s) as a separate file from upstream, the packager SHOULD query upstream to include it.
[/] SHOULD: The description and summary sections in the package spec file should contain translations for supported Non-English languages, if available.
[+] SHOULD: The reviewer should test that the package builds in mock. See MockTricks for details on how to do this.
[/] SHOULD: The package should compile and build into binary rpms on all supported architectures.
[/] SHOULD: The reviewer should test that the package functions as described. A package should not segfault instead of running, for example.
[/] SHOULD: If scriptlets are used, those scriptlets must be sane. This is vague, and left up to the reviewers judgement to determine sanity.
[/] SHOULD: Usually, subpackages other than devel should require the base package using a fully versioned dependency.
[/] SHOULD: The placement of pkgconfig(.pc) files depends on their usecase, and this is usually for development purposes, so should be placed in a -devel pkg.
[/] SHOULD: If the package has file dependencies outside of /etc, /bin, /sbin, /usr/bin, or /usr/sbin consider requiring the package which provides the file instead of the file itself.


=================================================

 The package mingw32-tcl is APPROVED by epienbro

=================================================
Comment 7 Thomas Sailer 2009-05-22 10:10:17 EDT
Thanks!

New Package CVS Request
=======================
Package Name: mingw32-tcl
Short Description: MinGW Windows Tool Command Language
Owners: sailer rjones
Branches: F-10 F-11
InitialCC:
Comment 8 Kevin Fenzi 2009-05-23 01:42:37 EDT
cvs done.
Comment 9 Fedora Update System 2009-05-23 08:55:07 EDT
mingw32-tcl-8.5.7-5.fc11.1 has been submitted as an update for Fedora 11.
http://admin.fedoraproject.org/updates/mingw32-tcl-8.5.7-5.fc11.1
Comment 10 Fedora Update System 2009-05-23 09:00:22 EDT
mingw32-tcl-8.5.7-5.fc10.1 has been submitted as an update for Fedora 10.
http://admin.fedoraproject.org/updates/mingw32-tcl-8.5.7-5.fc10.1
Comment 11 Fedora Update System 2009-05-25 17:17:02 EDT
mingw32-tcl-8.5.7-5.fc11.1 has been pushed to the Fedora 11 stable repository.  If problems still persist, please make note of it in this bug report.
Comment 12 Fedora Update System 2009-05-25 17:19:41 EDT
mingw32-tcl-8.5.7-5.fc10.1 has been pushed to the Fedora 10 stable repository.  If problems still persist, please make note of it in this bug report.

Note You need to log in before you can comment on or make changes to this bug.